const mongoose = require('mongoose').set('debug', false);
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = 'F';

const tools = require('../tools/general');

const {ObjectID} = require('mongodb');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true;
});

const CircuitSchema = new Schema({
  _id: {
    type: Number,
    unique: true,
  },
  name: {
    type: String,
    unique: true,
  },
  subname: {
    type: String,
  },
  descr: {
    type: String,
  },
  systemUserDescr: {
    type: String,
  },
  systemUserId: {
    type: String,
  },
  founderUserId: {
    type: String,
  },
  totCircolante: {
    type: Number,
  },
  totTransato: {
    type: Number,
  },
  nome_valuta: {
    type: String,
    maxlength: 20,
  },
  symbol: {
    type: String,
    maxlength: 3,
  },
  abbrev: {
    type: String,
    maxlength: 3,
  },
  compara_valuta: {
    type: Number,
    default: 1,
  },
  compara_euro: {
    type: Number,
    default: 1,
  },
  valuta_per_euro: {
    type: Number,
    default: 1,
  },
  fido_scoperto_default: {
    type: Number,
  },
  data_costituz: {
    type: Date,
  },
  deperimento: {
    type: Boolean,
    default: true,
  },
  freq_deper: {   // H, D, W, M, Y
    type: String,
  },
  minuto_deper: {
    type: Number,
  },
  ora_deper: {
    type: Number,
  },
  giorno_deper: {
    type: Number,
  },
  mese_deper: {
    type: Number,
  },
  ultimo_deper: {
    type: Date,
  },
  durata_deper: {
    type: Number,
  },
  // -------------
  img_logo: {
    type: String,
  },
});

CircuitSchema.statics.findAllIdApp = async function(idapp) {
  const MyCircuit = this;

  const myfind = {idapp};

  return await MyCircuit.find(myfind, (err, arrrec) => {
    return arrrec;
  });
};

CircuitSchema.pre('save', async function(next) {
  if (this.isNew) {
    const myrec = await Circuit.findOne().limit(1).sort({_id: -1});
    if (!!myrec) {
      if (myrec._doc._id === 0)
        this._id = 1;
      else
        this._id = myrec._doc._id + 1;

    } else {
      this._id = 1;
    }
  }

  next();
});

CircuitSchema.statics.getFieldsForSearch = function() {
  return [
    {field: 'nome_circuito', type: tools.FieldType.string},
    {field: 'sotto_nome', type: tools.FieldType.string},
    {field: 'nome_valuta', type: tools.FieldType.string},
    {field: 'descr', type: tools.FieldType.string}];
};

CircuitSchema.statics.executeQueryTable = function(idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, 0, params);
};

const Circuit = mongoose.model('Circuit', CircuitSchema);

module.exports = {Circuit};
